﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace ParameterAutoEncodeDecode
{
    public class RouteConfig
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");
            // 默认值
            RouteValueDictionary defaults = new RouteValueDictionary();
            defaults.Add("controller", "Home");
            defaults.Add("action", "Index");
            defaults.Add("id", "aa11");             

            // 注册路由,并指定自定义的路由处理器
            routes.Add("default", new Route("{controller}/{action}/{id}"
                            , defaults
                            , new GetEncodedIdRouteHandler()));

        }
    }

    /// <summary>
    /// 在路由处理器中修改参数值
    /// </summary>
    public class GetEncodedIdRouteHandler : IRouteHandler
    {
        public IHttpHandler GetHttpHandler(RequestContext requestContext)
        {
            // 对参数解密(将UrlExtensions中的UrlHelper扩展方法进行加密的参数进行相应的解密操作)
            // 这里只是将开头的aa给去除
            string id = requestContext.RouteData.Values["id"] == null ? "" : requestContext.RouteData.Values["id"].ToString().TrimStart('a');
            requestContext.RouteData.Values["id"] = id;
            return new MvcHandler(requestContext);
        }
    }
}
